<RccWorker language='c++' spec='drc' version='2'
	   controlOperations='start,stop,release'
	   staticprereqlibs='ad9361' >

  <specProperty name='MAX_CHANNELS_p' value="4"/>
  <specProperty name='MAX_RX_CHANNELS_p' value="2"/>
  <specProperty name='MAX_TX_CHANNELS_p' value="2"/>
  <specProperty name='MAX_RX_RF_PORTS_p' value="2"/>
  <specProperty name='MAX_TX_RF_PORTS_p' value="2"/>
  <specProperty name='rf_ports_rx' parameter='1' value='Rx0,Rx1'/>
  <specProperty name='rf_ports_tx' parameter='1' value='Tx0,Tx1'/>
  <specProperty name='prepare' writesync='1'/>
  <specProperty name='start' writesync='1'/>
  <specProperty name='stop' writesync='1'/>
  <specProperty name='release' writesync='1'/>
  <specProperty name='status' readsync='1'/>

  <slaves>
    <External name='rx' count='2'/>
    <External name='tx' count='2'/>
    <Instance worker='ocpi.platform.devices.platform_ad9361_config_csts.hdl' name='config'>
      <Property name='pin_control_p' value='true'/>
    </Instance>     
    <Instance worker='ocpi.platform.devices.platform_csts_ad9361_data_sub.hdl' name='data_sub'>
      <Property name='lvds_p' value='true'/>
      <Property name='DATA_CLK_Delay' value='3'/>
      <Property name='RX_Data_Delay' value='0'/>
      <Property name='FB_CLK_Delay' value='7'/>
      <Property name='TX_Data_Delay' value='0'/>
    </Instance>
    <!-- DRC RX0 path slaves -->
    <Instance worker='ocpi.platform.devices.data_src_qadc_csts.hdl'
	    name='rx_qadc0' connect='rx_csts_to_iqstream0'>
      <Property name='ADC_INPUT_IS_LSB_OF_OUT_PORT' value='true'/>
    </Instance>
    <Instance worker='ocpi.assets.misc_comps.csts_to_iqstream.hdl'
	  name='rx_csts_to_iqstream0' connect='rx_complex_mixer0'/>
    <Instance worker="ocpi.assets.dsp_comps.complex_mixer.hdl"
	  name='rx_complex_mixer0' connect='rx_cic_dec0'>
      <Property Name='NCO_DATA_WIDTH_p'   Value='12'/>
      <Property Name='INPUT_DATA_WIDTH_p' Value='12'/>
      <Property Name='mag' 		  Value='1024'/>
      <Property Name='phs_init'           Value='0'/>
    </Instance>
    <Instance worker='ocpi.assets.dsp_comps.cic_dec.hdl' name='rx_cic_dec0'>
      <Property Name='N'          Value='3'/>
      <Property Name='M'          Value='1'/>
      <Property Name='R'          Value='16'/> <!-- decimation factor -->
      <Property Name='ACC_WIDTH'  Value='28'/>
    </Instance>
    <Connection>
      <Port name='out' instance='rx_cic_dec0'/>
      <External name='rx' index='0'/>
    </Connection>

    <!-- Container only instances one RX channel at this time. -->
    <!-- A container/drc mismatch will prevent application from running. -->
    <!-- DRC RX1 path slaves -->
    <!--
    <Instance worker='ocpi.platform.devices.data_src_qadc_csts.hdl'
	    name='rx_qadc1' connect='rx_csts_to_iqstream1'>
      <Property name='ADC_INPUT_IS_LSB_OF_OUT_PORT' value='true'/>
    </Instance>
    <Instance worker='ocpi.assets.misc_comps.csts_to_iqstream.hdl'
	    name='rx_csts_to_iqstream1' connect='rx_complex_mixer1'/>
    <Instance worker="ocpi.assets.dsp_comps.complex_mixer.hdl"
	  name='rx_complex_mixer1' connect='rx_cic_dec1'>
      <Property Name='NCO_DATA_WIDTH_p'   Value='12'/>
      <Property Name='INPUT_DATA_WIDTH_p' Value='12'/>
      <Property Name='mag' 		  Value='1024'/>
      <Property Name='phs_init'           Value='0'/>
    </Instance>
    <Instance worker='ocpi.assets.dsp_comps.cic_dec.hdl' name='rx_cic_dec1'>
      <Property Name='N'          Value='3'/>
      <Property Name='M'          Value='1'/>
      <Property Name='R'          Value='16'/>
      <Property Name='ACC_WIDTH'  Value='28'/>
    </Instance>
    <Connection>
      <Port name='out' instance='rx_cic_dec1'/>
      <External name='rx' index='1'/>
    </Connection>
    -->
    <!-- DRC TX0 path slaves --> 
    <Connection>
      <External name='tx' index='0'/>
      <Port name='in' instance='tx_cic_int0'/>
    </Connection>
    <Instance worker='ocpi.assets.dsp_comps.cic_int.hdl'
          name='tx_cic_int0' connect='tx_iqstream_to_csts0'>
      <Property name='N'          Value='3'/>
      <Property name='M'          Value='1'/>
      <Property name='R'          Value='16'/> <!-- interpolation factor -->
      <Property name='ACC_WIDTH'  Value='28'/>
    </Instance>
    <Instance worker='ocpi.assets.misc_comps.iqstream_to_csts.hdl'
	  name='tx_iqstream_to_csts0' connect='tx_qdac0'/>
    <Instance worker='ocpi.platform.devices.data_sink_qdac_csts.hdl' name='tx_qdac0'>
      <Property name='DAC_OUTPUT_IS_LSB_OF_IN_PORT' value='false'/>
    </Instance>

    <!-- Container only instances one TX channel at this time. -->
    <!-- A container/drc mismatch will prevent application from running. -->
    <!-- 
    <Connection>
      <External name='tx' index='1'/>
      <Port name='in' instance='tx_cic_int1'/>
    </Connection>
    <Instance worker='ocpi.assets.dsp_comps.cic_int.hdl'
          name='tx_cic_int1' connect='tx_iqstream_to_csts1'>
      <Property name='N'          Value='3'/>
      <Property name='M'          Value='1'/>
      <Property name='R'          Value='16'/>
      <Property name='ACC_WIDTH'  Value='28'/>
    </Instance>
    <Instance worker='ocpi.assets.misc_comps.iqstream_to_csts.hdl'
		  name='tx_iqstream_to_csts1' connect='tx_qdac1'/>
    <Instance worker='ocpi.platform.devices.data_sink_qdac_csts.hdl' name='tx_qdac1'>
      <Property name='DAC_OUTPUT_IS_LSB_OF_IN_PORT' value='false'/>
    </Instance>
    -->
    <!--==========================================================================-->
    <!-- This must be instanced here in app XML as a workaround for #827/AV-3799 -->
    <!-- It is not really needed as a slave -->
    <Instance worker="ocpi.platform.devices.platform_ad9361_spi_csts.hdl" name='ad9361_spi'/>
  </slaves>
</RccWorker>
